#ifndef AUTO_CONTROL_HPP
#define AUTO_CONTROL_HPP

#include "Robot.hpp"
#include "ObjectSearcher.hpp"
#include "WebCam.hpp"
#include "SensorInfo.h"

ref class AutoControl{
	private:
		Robot* robot;
		ObjectSearcher^ os;
		WebCam^ webcam;
		System::Windows::Forms::PictureBox^ p_box;

	public:
		AutoControl(Robot* _robot,ObjectSearcher^ _os,WebCam^ _webcam,System::Windows::Forms::PictureBox^ _p_box);
		void AutoScan();
		void AutoDetect();

};

AutoControl::AutoControl(Robot* _robot,ObjectSearcher^ _os,WebCam^ _webcam,System::Windows::Forms::PictureBox^ _p_box){
	robot=_robot;
	os=_os;
	webcam=_webcam;
	p_box=_p_box;
}

void AutoControl::AutoScan(){
	std::ofstream f;
	f.open("autoscan.txt");
	int counter=0;
	for (int x=50;x<os->WsSizeX;x+=150){
		for (int y=50;y<os->WsSizeY;y+=200){
			f << os->WsCordX+x <<":" << os->WsCordY+y << " ";
			robot->Position(os->WsCordX+x,os->WsCordY+y);
			while (robot->IsMoving()){
				webcam->Refresh();
			}
			++counter;
			System::Drawing::Bitmap^ img=webcam->getImage();
			img->Save("Pictures\\Auto"+counter.ToString()+".png");
			os->Scan(img,Coord(os->WsCordX+x,os->WsCordY+y));
			f << "Picture Complete" << std::endl;
		}
	}
	robot->Exec(new Order("S9"));
	f.close();

}

void AutoControl::AutoDetect(){
	std::ofstream f;
	f.open("autodetect.txt");
	int counter=0;
	for (int i=0;i<os->canNumber();++i){
		int X=os->getCandidate(i).getCoord().getX()-os->offset_WebCamX;
		int Y=os->getCandidate(i).getCoord().getY()-os->offset_WebCamY;
		robot->Position(X,Y);
		while (robot->IsMoving()) {webcam->Refresh();}
		++counter;
		f << X-os->offset_WebCamX <<" : " << Y-os->offset_WebCamY << " ";
		System::Drawing::Bitmap^ img=webcam->getImage();
		img->Save("Pictures\\Detect"+counter.ToString()+".png");
		os->Detect(img,Coord(X,Y));
		f << "Picture Complete" << std::endl;
	}
	f.close();
}


#endif