#ifndef COORD_HPP
#define COORD_HPP
//****************************************************************************************************
//*                                              Includes                                            *
//****************************************************************************************************
#include <cmath>
//****************************************************************************************************
//*                                       Declaration of the Class                                   *
//****************************************************************************************************
//name: Coord
//description: A data class which stores coordination in a 2D Picture
//----------------------------------------------------------------------------------------------------
class Coord{
	private:
		int x;
		int y;
	public:
		Coord();
		Coord(int _x,int _y);
		int getX();
		int getY();
		void setX(int _x);
		void setY(int _y);
		static int distance(Coord c1,Coord c2);
};
//****************************************************************************************************
//*                                      Definition of the Functions                                 *
//****************************************************************************************************

//----------------------------------------------------------------------------------------------------
//name: Coord()
//return: -
//parameters: -
//description: Default Constructor 
//----------------------------------------------------------------------------------------------------
Coord::Coord(){
}

//----------------------------------------------------------------------------------------------------
//name: Coord()
//return: -
//parameters: int(x), int(y)
//description: Constructor which stores the coordination from parameters
//----------------------------------------------------------------------------------------------------
Coord::Coord(int _x, int _y){
	x=_x;
	y=_y;
}

//----------------------------------------------------------------------------------------------------
//name: getX()
//return: int
//parameters: -
//description: Function to get the x value of coordination
//----------------------------------------------------------------------------------------------------
int Coord::getX(){
	return x;
}

//----------------------------------------------------------------------------------------------------
//name: getY()
//return: int
//parameters: -
//description: Function to get the y value of coordination
//----------------------------------------------------------------------------------------------------
int Coord::getY(){
	return y;
}

//----------------------------------------------------------------------------------------------------
//name: setX()
//return: -
//parameters: int(x)
//description: Function to modify the x value of coordination
//----------------------------------------------------------------------------------------------------
void Coord::setX(int _x){
	x=_x;
}

//----------------------------------------------------------------------------------------------------
//name: setY()
//return: -
//parameters: int(y)
//description: Function to modify the y value of coordination
//----------------------------------------------------------------------------------------------------
void Coord::setY(int _y){
	y=_y;
}

//----------------------------------------------------------------------------------------------------
//name: setY()
//return: -
//parameters: int(y)
//description: Function to modify the y value of coordination
//----------------------------------------------------------------------------------------------------
int Coord::distance(Coord c1, Coord c2){
	int dx=c1.getX()-c2.getX();
	int dy=c1.getY()-c2.getY();
	return (int)sqrt((double)(dx*dx+dy*dy));
}
#endif