#pragma once

#include "highgui.h"
#include "Robot.hpp"
#include "ObjectSearcher.hpp"
#include "AutoControl.hpp"
#include "Server.hpp"
#include "PlanServer.hpp"
#include "WebCam.hpp"
#include <direct.h>
#include <string>

namespace PlotterController {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Net;
	using namespace System::Net::Sockets;

	/// <summary>
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();

			resourceManager = gcnew System::Resources::ResourceManager ("Resources",GetType()->Assembly);

			planserver=gcnew PlanServer(textBox_server_msg);
			server= gcnew Server(textBox_server_state);
			webcam= gcnew WebCam();
			objectsearcher=gcnew ObjectSearcher();

			sensorinfo= gcnew SensorInfo();

			pictureBox_WebCam->Image=gcnew Bitmap(640,480);
			image=gcnew Bitmap(640,480);

			counter=0;
			demo=0;

			connstat=ConnStatus::None;
			inputstat=InputStatus::No_Input;

						 sensorinfo = gcnew SensorInfo();
			//
			//TODO: Add the constructor code here
			//
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
			webcam->Release();
		}
	private: System::ComponentModel::IContainer^  components;
	protected: 

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
	private:
		Robot* robot;
		WebCam^ webcam;
		Bitmap^ image;
		Server^ server;

		SensorInfo^ sensorinfo;

			ConnStatus connstat;
			InputStatus inputstat;


		AutoControl^ autocontrol;
		PlanServer^ planserver;
		 int counter;
		 int demo;
		
		ObjectSearcher ^objectsearcher;
		System::Resources::ResourceManager^ resourceManager;

	private: System::Windows::Forms::PictureBox^  pictureBox_WebCam;
	private: System::Windows::Forms::Panel^  panelWebCam;
	private: System::Windows::Forms::Label^  label_webcam_controll;
	private: System::Windows::Forms::Button^  button_webcam_start;
	private: System::Windows::Forms::Button^  button_webcam_stop;
	private: System::Windows::Forms::Button^  button_webcam_capture;
	private: System::Windows::Forms::Button^  button_webcam_display;
	private: System::Windows::Forms::Timer^  timer_webcam;
	private: System::Windows::Forms::Panel^  panel_server;
	private: System::Windows::Forms::Button^  button_server_start;
	private: System::Windows::Forms::TextBox^  textBox_server_state;
	private: System::Windows::Forms::Timer^  timer_server;
	private: System::Windows::Forms::Button^  button_server_stop;





	private: System::Windows::Forms::Panel^  panel_client;
	private: System::Windows::Forms::Label^  label_client_controll;
	private: System::Windows::Forms::TextBox^  textBox_server_msg;

	private: System::Windows::Forms::ListBox^  listBox_precision;
	private: System::Windows::Forms::Button^  button_cubeXup;
	private: System::Windows::Forms::Button^  button_cubeYright;
	private: System::Windows::Forms::Button^  button_cubeYleft;
	private: System::Windows::Forms::Button^  button_cubeZdown;
	private: System::Windows::Forms::Button^  button_cubeZup;
	private: System::Windows::Forms::Button^  button_cubeXdown;
	private: System::Windows::Forms::Button^  button_cubeRleft;
	private: System::Windows::Forms::Button^  button_cubeRright;
	private: System::Windows::Forms::Button^  button_cubeGclose;
	private: System::Windows::Forms::Button^  button_cubeGopen;
	private: System::Windows::Forms::Button^  button_cubeXhome;
	private: System::Windows::Forms::Button^  button_cubeYhome;
	private: System::Windows::Forms::Button^  button_cubeZhome;
	private: System::Windows::Forms::Button^  button_cubeGhome;
	private: System::Windows::Forms::Button^  button_cubeRhome;
	private: System::Windows::Forms::Button^  button_haltall;
	private: System::Windows::Forms::Panel^  panel_plotterstage;
	private: System::Windows::Forms::Label^  label_plotterstage;
	private: System::Windows::Forms::Button^  button_initialization;


	private: System::Windows::Forms::Timer^  timer_plotter;
	private: System::Windows::Forms::TextBox^  textBox_cubeX;
	private: System::Windows::Forms::TextBox^  textBox_cubeY;
	private: System::Windows::Forms::TextBox^  textBox_cubeZ;
	private: System::Windows::Forms::TextBox^  textBox_cubeR;
	private: System::Windows::Forms::TextBox^  textBox_cubeG;
	private: System::Windows::Forms::CheckBox^  checkBox_cubeX;
	private: System::Windows::Forms::CheckBox^  checkBox_cubeY;
	private: System::Windows::Forms::CheckBox^  checkBox_cubeZ;
	private: System::Windows::Forms::CheckBox^  checkBox_cubeR;
	private: System::Windows::Forms::CheckBox^  checkBox_cubeG;




private: System::Windows::Forms::Panel^  panel_automod;
private: System::Windows::Forms::Button^  button_autosave;
private: System::Windows::Forms::TextBox^  textBox_autofilename;
private: System::Windows::Forms::Panel^  panel_demo;
private: System::Windows::Forms::Button^  button_demo_detect;
private: System::Windows::Forms::Timer^  timer_server2;
private: System::Windows::Forms::Button^  button_auto_send;

private: System::Windows::Forms::Button^  button_demo_load;
private: System::Windows::Forms::Button^  button_auto_detect;
private: System::Windows::Forms::Button^  button_auto_scan;
private: System::Windows::Forms::Button^  button_demo_scan;
private: System::Windows::Forms::Button^  button_demo_nextstep;
private: System::Windows::Forms::ListBox^  listBox_demo;
private: System::Windows::Forms::TextBox^  textBox_demo;
private: System::Windows::Forms::Label^  label_sensorOK;
private: System::Windows::Forms::Timer^  timer_sensor;


	private: System::Windows::Forms::Label^  label_server;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(Form1::typeid));
			this->pictureBox_WebCam = (gcnew System::Windows::Forms::PictureBox());
			this->panelWebCam = (gcnew System::Windows::Forms::Panel());
			this->button_webcam_display = (gcnew System::Windows::Forms::Button());
			this->button_webcam_capture = (gcnew System::Windows::Forms::Button());
			this->button_webcam_stop = (gcnew System::Windows::Forms::Button());
			this->button_webcam_start = (gcnew System::Windows::Forms::Button());
			this->label_webcam_controll = (gcnew System::Windows::Forms::Label());
			this->timer_webcam = (gcnew System::Windows::Forms::Timer(this->components));
			this->panel_server = (gcnew System::Windows::Forms::Panel());
			this->textBox_server_msg = (gcnew System::Windows::Forms::TextBox());
			this->button_server_stop = (gcnew System::Windows::Forms::Button());
			this->textBox_server_state = (gcnew System::Windows::Forms::TextBox());
			this->button_server_start = (gcnew System::Windows::Forms::Button());
			this->label_server = (gcnew System::Windows::Forms::Label());
			this->timer_server = (gcnew System::Windows::Forms::Timer(this->components));
			this->panel_client = (gcnew System::Windows::Forms::Panel());
			this->checkBox_cubeG = (gcnew System::Windows::Forms::CheckBox());
			this->checkBox_cubeR = (gcnew System::Windows::Forms::CheckBox());
			this->checkBox_cubeZ = (gcnew System::Windows::Forms::CheckBox());
			this->checkBox_cubeY = (gcnew System::Windows::Forms::CheckBox());
			this->checkBox_cubeX = (gcnew System::Windows::Forms::CheckBox());
			this->textBox_cubeG = (gcnew System::Windows::Forms::TextBox());
			this->textBox_cubeR = (gcnew System::Windows::Forms::TextBox());
			this->textBox_cubeZ = (gcnew System::Windows::Forms::TextBox());
			this->textBox_cubeY = (gcnew System::Windows::Forms::TextBox());
			this->textBox_cubeX = (gcnew System::Windows::Forms::TextBox());
			this->button_haltall = (gcnew System::Windows::Forms::Button());
			this->button_cubeGhome = (gcnew System::Windows::Forms::Button());
			this->button_cubeRhome = (gcnew System::Windows::Forms::Button());
			this->button_cubeZhome = (gcnew System::Windows::Forms::Button());
			this->button_cubeYhome = (gcnew System::Windows::Forms::Button());
			this->button_cubeXhome = (gcnew System::Windows::Forms::Button());
			this->button_cubeGclose = (gcnew System::Windows::Forms::Button());
			this->button_cubeGopen = (gcnew System::Windows::Forms::Button());
			this->button_cubeRright = (gcnew System::Windows::Forms::Button());
			this->button_cubeRleft = (gcnew System::Windows::Forms::Button());
			this->button_cubeZdown = (gcnew System::Windows::Forms::Button());
			this->button_cubeZup = (gcnew System::Windows::Forms::Button());
			this->button_cubeXdown = (gcnew System::Windows::Forms::Button());
			this->button_cubeXup = (gcnew System::Windows::Forms::Button());
			this->button_cubeYright = (gcnew System::Windows::Forms::Button());
			this->button_cubeYleft = (gcnew System::Windows::Forms::Button());
			this->listBox_precision = (gcnew System::Windows::Forms::ListBox());
			this->label_client_controll = (gcnew System::Windows::Forms::Label());
			this->panel_plotterstage = (gcnew System::Windows::Forms::Panel());
			this->label_sensorOK = (gcnew System::Windows::Forms::Label());
			this->button_initialization = (gcnew System::Windows::Forms::Button());
			this->label_plotterstage = (gcnew System::Windows::Forms::Label());
			this->timer_plotter = (gcnew System::Windows::Forms::Timer(this->components));
			this->panel_automod = (gcnew System::Windows::Forms::Panel());
			this->button_auto_scan = (gcnew System::Windows::Forms::Button());
			this->button_auto_detect = (gcnew System::Windows::Forms::Button());
			this->button_auto_send = (gcnew System::Windows::Forms::Button());
			this->textBox_autofilename = (gcnew System::Windows::Forms::TextBox());
			this->button_autosave = (gcnew System::Windows::Forms::Button());
			this->panel_demo = (gcnew System::Windows::Forms::Panel());
			this->textBox_demo = (gcnew System::Windows::Forms::TextBox());
			this->listBox_demo = (gcnew System::Windows::Forms::ListBox());
			this->button_demo_nextstep = (gcnew System::Windows::Forms::Button());
			this->button_demo_scan = (gcnew System::Windows::Forms::Button());
			this->button_demo_load = (gcnew System::Windows::Forms::Button());
			this->button_demo_detect = (gcnew System::Windows::Forms::Button());
			this->timer_server2 = (gcnew System::Windows::Forms::Timer(this->components));
			this->timer_sensor = (gcnew System::Windows::Forms::Timer(this->components));
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox_WebCam))->BeginInit();
			this->panelWebCam->SuspendLayout();
			this->panel_server->SuspendLayout();
			this->panel_client->SuspendLayout();
			this->panel_plotterstage->SuspendLayout();
			this->panel_automod->SuspendLayout();
			this->panel_demo->SuspendLayout();
			this->SuspendLayout();
			// 
			// pictureBox_WebCam
			// 
			this->pictureBox_WebCam->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->pictureBox_WebCam->Location = System::Drawing::Point(5, 5);
			this->pictureBox_WebCam->Name = L"pictureBox_WebCam";
			this->pictureBox_WebCam->Size = System::Drawing::Size(640, 481);
			this->pictureBox_WebCam->TabIndex = 0;
			this->pictureBox_WebCam->TabStop = false;
			// 
			// panelWebCam
			// 
			this->panelWebCam->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->panelWebCam->Controls->Add(this->button_webcam_display);
			this->panelWebCam->Controls->Add(this->button_webcam_capture);
			this->panelWebCam->Controls->Add(this->button_webcam_stop);
			this->panelWebCam->Controls->Add(this->button_webcam_start);
			this->panelWebCam->Controls->Add(this->label_webcam_controll);
			this->panelWebCam->Location = System::Drawing::Point(650, 210);
			this->panelWebCam->Name = L"panelWebCam";
			this->panelWebCam->Size = System::Drawing::Size(135, 105);
			this->panelWebCam->TabIndex = 1;
			// 
			// button_webcam_display
			// 
			this->button_webcam_display->Enabled = false;
			this->button_webcam_display->Font = (gcnew System::Drawing::Font(L"Arial", 9, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_webcam_display->Location = System::Drawing::Point(70, 54);
			this->button_webcam_display->Name = L"button_webcam_display";
			this->button_webcam_display->Size = System::Drawing::Size(60, 43);
			this->button_webcam_display->TabIndex = 4;
			this->button_webcam_display->Text = L"Display";
			this->button_webcam_display->UseVisualStyleBackColor = true;
			this->button_webcam_display->Click += gcnew System::EventHandler(this, &Form1::button_webcam_display_Click);
			// 
			// button_webcam_capture
			// 
			this->button_webcam_capture->Enabled = false;
			this->button_webcam_capture->Font = (gcnew System::Drawing::Font(L"Arial", 9, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_webcam_capture->Location = System::Drawing::Point(5, 54);
			this->button_webcam_capture->Name = L"button_webcam_capture";
			this->button_webcam_capture->Size = System::Drawing::Size(60, 43);
			this->button_webcam_capture->TabIndex = 3;
			this->button_webcam_capture->Text = L"Capture";
			this->button_webcam_capture->UseVisualStyleBackColor = true;
			this->button_webcam_capture->Click += gcnew System::EventHandler(this, &Form1::button_webcam_capture_Click);
			// 
			// button_webcam_stop
			// 
			this->button_webcam_stop->Enabled = false;
			this->button_webcam_stop->Font = (gcnew System::Drawing::Font(L"Arial", 9, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_webcam_stop->Location = System::Drawing::Point(70, 27);
			this->button_webcam_stop->Name = L"button_webcam_stop";
			this->button_webcam_stop->Size = System::Drawing::Size(60, 22);
			this->button_webcam_stop->TabIndex = 2;
			this->button_webcam_stop->Text = L"Stop";
			this->button_webcam_stop->UseVisualStyleBackColor = true;
			this->button_webcam_stop->Click += gcnew System::EventHandler(this, &Form1::button_webcam_stop_Click);
			// 
			// button_webcam_start
			// 
			this->button_webcam_start->Font = (gcnew System::Drawing::Font(L"Arial", 9, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_webcam_start->Location = System::Drawing::Point(5, 27);
			this->button_webcam_start->Name = L"button_webcam_start";
			this->button_webcam_start->Size = System::Drawing::Size(60, 22);
			this->button_webcam_start->TabIndex = 1;
			this->button_webcam_start->Text = L"Start";
			this->button_webcam_start->UseVisualStyleBackColor = true;
			this->button_webcam_start->Click += gcnew System::EventHandler(this, &Form1::button_webcam_start_Click);
			// 
			// label_webcam_controll
			// 
			this->label_webcam_controll->Font = (gcnew System::Drawing::Font(L"Arial", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->label_webcam_controll->Location = System::Drawing::Point(5, 5);
			this->label_webcam_controll->Name = L"label_webcam_controll";
			this->label_webcam_controll->Size = System::Drawing::Size(125, 16);
			this->label_webcam_controll->TabIndex = 0;
			this->label_webcam_controll->Text = L"WebCam Control";
			this->label_webcam_controll->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			// 
			// timer_webcam
			// 
			this->timer_webcam->Interval = 10;
			this->timer_webcam->Tick += gcnew System::EventHandler(this, &Form1::timer_webcam_Tick);
			// 
			// panel_server
			// 
			this->panel_server->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->panel_server->Controls->Add(this->textBox_server_msg);
			this->panel_server->Controls->Add(this->button_server_stop);
			this->panel_server->Controls->Add(this->textBox_server_state);
			this->panel_server->Controls->Add(this->button_server_start);
			this->panel_server->Controls->Add(this->label_server);
			this->panel_server->Location = System::Drawing::Point(650, 85);
			this->panel_server->Name = L"panel_server";
			this->panel_server->Size = System::Drawing::Size(135, 120);
			this->panel_server->TabIndex = 2;
			// 
			// textBox_server_msg
			// 
			this->textBox_server_msg->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->textBox_server_msg->Font = (gcnew System::Drawing::Font(L"Arial", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->textBox_server_msg->Location = System::Drawing::Point(5, 87);
			this->textBox_server_msg->Name = L"textBox_server_msg";
			this->textBox_server_msg->ReadOnly = true;
			this->textBox_server_msg->Size = System::Drawing::Size(125, 22);
			this->textBox_server_msg->TabIndex = 9;
			this->textBox_server_msg->TextAlign = System::Windows::Forms::HorizontalAlignment::Center;
			// 
			// button_server_stop
			// 
			this->button_server_stop->Enabled = false;
			this->button_server_stop->Font = (gcnew System::Drawing::Font(L"Arial", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_server_stop->Location = System::Drawing::Point(70, 59);
			this->button_server_stop->Name = L"button_server_stop";
			this->button_server_stop->Size = System::Drawing::Size(60, 22);
			this->button_server_stop->TabIndex = 3;
			this->button_server_stop->Text = L"Stop";
			this->button_server_stop->UseVisualStyleBackColor = true;
			this->button_server_stop->Click += gcnew System::EventHandler(this, &Form1::button_server_stop_Click);
			// 
			// textBox_server_state
			// 
			this->textBox_server_state->BackColor = System::Drawing::SystemColors::Control;
			this->textBox_server_state->Font = (gcnew System::Drawing::Font(L"Arial", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->textBox_server_state->Location = System::Drawing::Point(10, 27);
			this->textBox_server_state->Name = L"textBox_server_state";
			this->textBox_server_state->ReadOnly = true;
			this->textBox_server_state->Size = System::Drawing::Size(110, 22);
			this->textBox_server_state->TabIndex = 2;
			this->textBox_server_state->Text = L"Stopped";
			this->textBox_server_state->TextAlign = System::Windows::Forms::HorizontalAlignment::Center;
			// 
			// button_server_start
			// 
			this->button_server_start->Enabled = false;
			this->button_server_start->Font = (gcnew System::Drawing::Font(L"Arial", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_server_start->Location = System::Drawing::Point(5, 59);
			this->button_server_start->Name = L"button_server_start";
			this->button_server_start->Size = System::Drawing::Size(60, 22);
			this->button_server_start->TabIndex = 1;
			this->button_server_start->Text = L"Start";
			this->button_server_start->UseVisualStyleBackColor = true;
			this->button_server_start->Click += gcnew System::EventHandler(this, &Form1::button_server_start_Click);
			// 
			// label_server
			// 
			this->label_server->Font = (gcnew System::Drawing::Font(L"Arial", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->label_server->Location = System::Drawing::Point(5, 5);
			this->label_server->Name = L"label_server";
			this->label_server->Size = System::Drawing::Size(125, 16);
			this->label_server->TabIndex = 0;
			this->label_server->Text = L"Server Control";
			this->label_server->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			// 
			// timer_server
			// 
			this->timer_server->Interval = 10;
			this->timer_server->Tick += gcnew System::EventHandler(this, &Form1::timer_server_Tick);
			// 
			// panel_client
			// 
			this->panel_client->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->panel_client->Controls->Add(this->checkBox_cubeG);
			this->panel_client->Controls->Add(this->checkBox_cubeR);
			this->panel_client->Controls->Add(this->checkBox_cubeZ);
			this->panel_client->Controls->Add(this->checkBox_cubeY);
			this->panel_client->Controls->Add(this->checkBox_cubeX);
			this->panel_client->Controls->Add(this->textBox_cubeG);
			this->panel_client->Controls->Add(this->textBox_cubeR);
			this->panel_client->Controls->Add(this->textBox_cubeZ);
			this->panel_client->Controls->Add(this->textBox_cubeY);
			this->panel_client->Controls->Add(this->textBox_cubeX);
			this->panel_client->Controls->Add(this->button_haltall);
			this->panel_client->Controls->Add(this->button_cubeGhome);
			this->panel_client->Controls->Add(this->button_cubeRhome);
			this->panel_client->Controls->Add(this->button_cubeZhome);
			this->panel_client->Controls->Add(this->button_cubeYhome);
			this->panel_client->Controls->Add(this->button_cubeXhome);
			this->panel_client->Controls->Add(this->button_cubeGclose);
			this->panel_client->Controls->Add(this->button_cubeGopen);
			this->panel_client->Controls->Add(this->button_cubeRright);
			this->panel_client->Controls->Add(this->button_cubeRleft);
			this->panel_client->Controls->Add(this->button_cubeZdown);
			this->panel_client->Controls->Add(this->button_cubeZup);
			this->panel_client->Controls->Add(this->button_cubeXdown);
			this->panel_client->Controls->Add(this->button_cubeXup);
			this->panel_client->Controls->Add(this->button_cubeYright);
			this->panel_client->Controls->Add(this->button_cubeYleft);
			this->panel_client->Controls->Add(this->listBox_precision);
			this->panel_client->Controls->Add(this->label_client_controll);
			this->panel_client->Location = System::Drawing::Point(650, 320);
			this->panel_client->Name = L"panel_client";
			this->panel_client->Size = System::Drawing::Size(135, 270);
			this->panel_client->TabIndex = 4;
			// 
			// checkBox_cubeG
			// 
			this->checkBox_cubeG->Enabled = false;
			this->checkBox_cubeG->Location = System::Drawing::Point(115, 245);
			this->checkBox_cubeG->Name = L"checkBox_cubeG";
			this->checkBox_cubeG->Size = System::Drawing::Size(15, 15);
			this->checkBox_cubeG->TabIndex = 28;
			this->checkBox_cubeG->UseVisualStyleBackColor = true;
			// 
			// checkBox_cubeR
			// 
			this->checkBox_cubeR->Enabled = false;
			this->checkBox_cubeR->Location = System::Drawing::Point(87, 245);
			this->checkBox_cubeR->Name = L"checkBox_cubeR";
			this->checkBox_cubeR->Size = System::Drawing::Size(15, 15);
			this->checkBox_cubeR->TabIndex = 27;
			this->checkBox_cubeR->UseVisualStyleBackColor = true;
			// 
			// checkBox_cubeZ
			// 
			this->checkBox_cubeZ->Enabled = false;
			this->checkBox_cubeZ->Location = System::Drawing::Point(60, 245);
			this->checkBox_cubeZ->Name = L"checkBox_cubeZ";
			this->checkBox_cubeZ->Size = System::Drawing::Size(15, 15);
			this->checkBox_cubeZ->TabIndex = 26;
			this->checkBox_cubeZ->UseVisualStyleBackColor = true;
			// 
			// checkBox_cubeY
			// 
			this->checkBox_cubeY->Enabled = false;
			this->checkBox_cubeY->Location = System::Drawing::Point(32, 245);
			this->checkBox_cubeY->Name = L"checkBox_cubeY";
			this->checkBox_cubeY->Size = System::Drawing::Size(15, 15);
			this->checkBox_cubeY->TabIndex = 25;
			this->checkBox_cubeY->UseVisualStyleBackColor = true;
			// 
			// checkBox_cubeX
			// 
			this->checkBox_cubeX->Enabled = false;
			this->checkBox_cubeX->Location = System::Drawing::Point(5, 245);
			this->checkBox_cubeX->Name = L"checkBox_cubeX";
			this->checkBox_cubeX->Size = System::Drawing::Size(15, 15);
			this->checkBox_cubeX->TabIndex = 24;
			this->checkBox_cubeX->UseVisualStyleBackColor = true;
			// 
			// textBox_cubeG
			// 
			this->textBox_cubeG->BackColor = System::Drawing::SystemColors::Control;
			this->textBox_cubeG->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->textBox_cubeG->Enabled = false;
			this->textBox_cubeG->Font = (gcnew System::Drawing::Font(L"Arial", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->textBox_cubeG->Location = System::Drawing::Point(89, 220);
			this->textBox_cubeG->Name = L"textBox_cubeG";
			this->textBox_cubeG->ReadOnly = true;
			this->textBox_cubeG->Size = System::Drawing::Size(40, 22);
			this->textBox_cubeG->TabIndex = 23;
			this->textBox_cubeG->TextAlign = System::Windows::Forms::HorizontalAlignment::Center;
			// 
			// textBox_cubeR
			// 
			this->textBox_cubeR->BackColor = System::Drawing::SystemColors::Control;
			this->textBox_cubeR->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->textBox_cubeR->Enabled = false;
			this->textBox_cubeR->Font = (gcnew System::Drawing::Font(L"Arial", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->textBox_cubeR->Location = System::Drawing::Point(47, 220);
			this->textBox_cubeR->Name = L"textBox_cubeR";
			this->textBox_cubeR->ReadOnly = true;
			this->textBox_cubeR->Size = System::Drawing::Size(40, 22);
			this->textBox_cubeR->TabIndex = 22;
			this->textBox_cubeR->TextAlign = System::Windows::Forms::HorizontalAlignment::Center;
			// 
			// textBox_cubeZ
			// 
			this->textBox_cubeZ->BackColor = System::Drawing::SystemColors::Control;
			this->textBox_cubeZ->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->textBox_cubeZ->Enabled = false;
			this->textBox_cubeZ->Font = (gcnew System::Drawing::Font(L"Arial", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->textBox_cubeZ->Location = System::Drawing::Point(5, 220);
			this->textBox_cubeZ->Name = L"textBox_cubeZ";
			this->textBox_cubeZ->ReadOnly = true;
			this->textBox_cubeZ->Size = System::Drawing::Size(40, 22);
			this->textBox_cubeZ->TabIndex = 21;
			this->textBox_cubeZ->TextAlign = System::Windows::Forms::HorizontalAlignment::Center;
			// 
			// textBox_cubeY
			// 
			this->textBox_cubeY->BackColor = System::Drawing::SystemColors::Control;
			this->textBox_cubeY->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->textBox_cubeY->Enabled = false;
			this->textBox_cubeY->Font = (gcnew System::Drawing::Font(L"Arial", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->textBox_cubeY->Location = System::Drawing::Point(69, 195);
			this->textBox_cubeY->Name = L"textBox_cubeY";
			this->textBox_cubeY->ReadOnly = true;
			this->textBox_cubeY->Size = System::Drawing::Size(60, 22);
			this->textBox_cubeY->TabIndex = 20;
			this->textBox_cubeY->TextAlign = System::Windows::Forms::HorizontalAlignment::Center;
			// 
			// textBox_cubeX
			// 
			this->textBox_cubeX->BackColor = System::Drawing::SystemColors::Control;
			this->textBox_cubeX->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->textBox_cubeX->Enabled = false;
			this->textBox_cubeX->Font = (gcnew System::Drawing::Font(L"Arial", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->textBox_cubeX->Location = System::Drawing::Point(5, 195);
			this->textBox_cubeX->Name = L"textBox_cubeX";
			this->textBox_cubeX->ReadOnly = true;
			this->textBox_cubeX->Size = System::Drawing::Size(60, 22);
			this->textBox_cubeX->TabIndex = 19;
			this->textBox_cubeX->TextAlign = System::Windows::Forms::HorizontalAlignment::Center;
			// 
			// button_haltall
			// 
			this->button_haltall->Enabled = false;
			this->button_haltall->Font = (gcnew System::Drawing::Font(L"Arial", 9, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_haltall->Location = System::Drawing::Point(10, 165);
			this->button_haltall->Name = L"button_haltall";
			this->button_haltall->Size = System::Drawing::Size(50, 22);
			this->button_haltall->TabIndex = 18;
			this->button_haltall->Text = L"Stop";
			this->button_haltall->UseVisualStyleBackColor = true;
			this->button_haltall->Click += gcnew System::EventHandler(this, &Form1::button_haltall_Click);
			// 
			// button_cubeGhome
			// 
			this->button_cubeGhome->Enabled = false;
			this->button_cubeGhome->Font = (gcnew System::Drawing::Font(L"Arial", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_cubeGhome->Location = System::Drawing::Point(110, 139);
			this->button_cubeGhome->Name = L"button_cubeGhome";
			this->button_cubeGhome->Size = System::Drawing::Size(20, 20);
			this->button_cubeGhome->TabIndex = 17;
			this->button_cubeGhome->Text = L"G";
			this->button_cubeGhome->UseVisualStyleBackColor = true;
			this->button_cubeGhome->Click += gcnew System::EventHandler(this, &Form1::button_cubeGhome_Click);
			// 
			// button_cubeRhome
			// 
			this->button_cubeRhome->Enabled = false;
			this->button_cubeRhome->Font = (gcnew System::Drawing::Font(L"Arial", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_cubeRhome->Location = System::Drawing::Point(110, 119);
			this->button_cubeRhome->Name = L"button_cubeRhome";
			this->button_cubeRhome->Size = System::Drawing::Size(20, 20);
			this->button_cubeRhome->TabIndex = 16;
			this->button_cubeRhome->Text = L"R";
			this->button_cubeRhome->UseVisualStyleBackColor = true;
			this->button_cubeRhome->Click += gcnew System::EventHandler(this, &Form1::button_cubeRhome_Click);
			// 
			// button_cubeZhome
			// 
			this->button_cubeZhome->Enabled = false;
			this->button_cubeZhome->Font = (gcnew System::Drawing::Font(L"Arial", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_cubeZhome->Location = System::Drawing::Point(110, 99);
			this->button_cubeZhome->Name = L"button_cubeZhome";
			this->button_cubeZhome->Size = System::Drawing::Size(20, 20);
			this->button_cubeZhome->TabIndex = 15;
			this->button_cubeZhome->Text = L"Z";
			this->button_cubeZhome->UseVisualStyleBackColor = true;
			this->button_cubeZhome->Click += gcnew System::EventHandler(this, &Form1::button_cubeZhome_Click);
			// 
			// button_cubeYhome
			// 
			this->button_cubeYhome->Enabled = false;
			this->button_cubeYhome->Font = (gcnew System::Drawing::Font(L"Arial", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_cubeYhome->Location = System::Drawing::Point(110, 79);
			this->button_cubeYhome->Name = L"button_cubeYhome";
			this->button_cubeYhome->Size = System::Drawing::Size(20, 20);
			this->button_cubeYhome->TabIndex = 14;
			this->button_cubeYhome->Text = L"Y";
			this->button_cubeYhome->UseVisualStyleBackColor = true;
			this->button_cubeYhome->Click += gcnew System::EventHandler(this, &Form1::button_cubeYhome_Click);
			// 
			// button_cubeXhome
			// 
			this->button_cubeXhome->Enabled = false;
			this->button_cubeXhome->Font = (gcnew System::Drawing::Font(L"Arial", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_cubeXhome->Location = System::Drawing::Point(110, 59);
			this->button_cubeXhome->Name = L"button_cubeXhome";
			this->button_cubeXhome->Size = System::Drawing::Size(20, 20);
			this->button_cubeXhome->TabIndex = 13;
			this->button_cubeXhome->Text = L"X";
			this->button_cubeXhome->UseVisualStyleBackColor = true;
			this->button_cubeXhome->Click += gcnew System::EventHandler(this, &Form1::button_cubeXhome_Click);
			// 
			// button_cubeGclose
			// 
			this->button_cubeGclose->Enabled = false;
			this->button_cubeGclose->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"button_cubeGclose.Image")));
			this->button_cubeGclose->Location = System::Drawing::Point(57, 142);
			this->button_cubeGclose->Name = L"button_cubeGclose";
			this->button_cubeGclose->Size = System::Drawing::Size(48, 19);
			this->button_cubeGclose->TabIndex = 12;
			this->button_cubeGclose->UseVisualStyleBackColor = true;
			this->button_cubeGclose->Click += gcnew System::EventHandler(this, &Form1::button_cubeGclose_Click);
			// 
			// button_cubeGopen
			// 
			this->button_cubeGopen->Enabled = false;
			this->button_cubeGopen->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"button_cubeGopen.Image")));
			this->button_cubeGopen->Location = System::Drawing::Point(57, 124);
			this->button_cubeGopen->Name = L"button_cubeGopen";
			this->button_cubeGopen->Size = System::Drawing::Size(48, 19);
			this->button_cubeGopen->TabIndex = 11;
			this->button_cubeGopen->UseVisualStyleBackColor = true;
			this->button_cubeGopen->Click += gcnew System::EventHandler(this, &Form1::button_cubeGopen_Click);
			// 
			// button_cubeRright
			// 
			this->button_cubeRright->Enabled = false;
			this->button_cubeRright->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"button_cubeRright.Image")));
			this->button_cubeRright->Location = System::Drawing::Point(33, 124);
			this->button_cubeRright->Name = L"button_cubeRright";
			this->button_cubeRright->Size = System::Drawing::Size(24, 36);
			this->button_cubeRright->TabIndex = 10;
			this->button_cubeRright->UseVisualStyleBackColor = true;
			this->button_cubeRright->Click += gcnew System::EventHandler(this, &Form1::button_cubeRright_Click);
			// 
			// button_cubeRleft
			// 
			this->button_cubeRleft->Enabled = false;
			this->button_cubeRleft->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"button_cubeRleft.Image")));
			this->button_cubeRleft->Location = System::Drawing::Point(10, 124);
			this->button_cubeRleft->Name = L"button_cubeRleft";
			this->button_cubeRleft->Size = System::Drawing::Size(24, 36);
			this->button_cubeRleft->TabIndex = 9;
			this->button_cubeRleft->UseVisualStyleBackColor = true;
			this->button_cubeRleft->Click += gcnew System::EventHandler(this, &Form1::button_cubeRleft_Click);
			// 
			// button_cubeZdown
			// 
			this->button_cubeZdown->Enabled = false;
			this->button_cubeZdown->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"button_cubeZdown.Image")));
			this->button_cubeZdown->Location = System::Drawing::Point(57, 78);
			this->button_cubeZdown->Name = L"button_cubeZdown";
			this->button_cubeZdown->Size = System::Drawing::Size(24, 26);
			this->button_cubeZdown->TabIndex = 8;
			this->button_cubeZdown->UseVisualStyleBackColor = true;
			this->button_cubeZdown->Click += gcnew System::EventHandler(this, &Form1::button_cubeZdown_Click);
			// 
			// button_cubeZup
			// 
			this->button_cubeZup->Enabled = false;
			this->button_cubeZup->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"button_cubeZup.Image")));
			this->button_cubeZup->Location = System::Drawing::Point(33, 78);
			this->button_cubeZup->Name = L"button_cubeZup";
			this->button_cubeZup->Size = System::Drawing::Size(24, 26);
			this->button_cubeZup->TabIndex = 7;
			this->button_cubeZup->UseVisualStyleBackColor = true;
			this->button_cubeZup->Click += gcnew System::EventHandler(this, &Form1::button_cubeZup_Click);
			// 
			// button_cubeXdown
			// 
			this->button_cubeXdown->Enabled = false;
			this->button_cubeXdown->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"button_cubeXdown.Image")));
			this->button_cubeXdown->Location = System::Drawing::Point(33, 103);
			this->button_cubeXdown->Name = L"button_cubeXdown";
			this->button_cubeXdown->Size = System::Drawing::Size(48, 19);
			this->button_cubeXdown->TabIndex = 6;
			this->button_cubeXdown->UseVisualStyleBackColor = true;
			this->button_cubeXdown->Click += gcnew System::EventHandler(this, &Form1::button_cubeXdown_Click);
			// 
			// button_cubeXup
			// 
			this->button_cubeXup->Enabled = false;
			this->button_cubeXup->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"button_cubeXup.Image")));
			this->button_cubeXup->Location = System::Drawing::Point(33, 59);
			this->button_cubeXup->Name = L"button_cubeXup";
			this->button_cubeXup->Size = System::Drawing::Size(48, 19);
			this->button_cubeXup->TabIndex = 5;
			this->button_cubeXup->UseVisualStyleBackColor = true;
			this->button_cubeXup->Click += gcnew System::EventHandler(this, &Form1::button_cubeXup_Click);
			// 
			// button_cubeYright
			// 
			this->button_cubeYright->Enabled = false;
			this->button_cubeYright->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"button_cubeYright.Image")));
			this->button_cubeYright->Location = System::Drawing::Point(80, 73);
			this->button_cubeYright->Name = L"button_cubeYright";
			this->button_cubeYright->Size = System::Drawing::Size(24, 36);
			this->button_cubeYright->TabIndex = 4;
			this->button_cubeYright->UseVisualStyleBackColor = true;
			this->button_cubeYright->Click += gcnew System::EventHandler(this, &Form1::button_cubeYright_Click);
			// 
			// button_cubeYleft
			// 
			this->button_cubeYleft->Enabled = false;
			this->button_cubeYleft->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"button_cubeYleft.Image")));
			this->button_cubeYleft->Location = System::Drawing::Point(10, 73);
			this->button_cubeYleft->Name = L"button_cubeYleft";
			this->button_cubeYleft->Size = System::Drawing::Size(24, 36);
			this->button_cubeYleft->TabIndex = 3;
			this->button_cubeYleft->UseVisualStyleBackColor = true;
			this->button_cubeYleft->Click += gcnew System::EventHandler(this, &Form1::button_cubeYleft_Click);
			// 
			// listBox_precision
			// 
			this->listBox_precision->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->listBox_precision->Enabled = false;
			this->listBox_precision->Font = (gcnew System::Drawing::Font(L"Arial", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->listBox_precision->FormattingEnabled = true;
			this->listBox_precision->ItemHeight = 14;
			this->listBox_precision->Items->AddRange(gcnew cli::array< System::Object^  >(4) {L"   1 cm  /  1 ", L"   5 cm  /  5", 
				L" 10 cm  /  15", L" 25 cm  /  30"});
			this->listBox_precision->Location = System::Drawing::Point(17, 35);
			this->listBox_precision->Name = L"listBox_precision";
			this->listBox_precision->Size = System::Drawing::Size(100, 16);
			this->listBox_precision->TabIndex = 2;
			// 
			// label_client_controll
			// 
			this->label_client_controll->Font = (gcnew System::Drawing::Font(L"Arial", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->label_client_controll->Location = System::Drawing::Point(5, 5);
			this->label_client_controll->Name = L"label_client_controll";
			this->label_client_controll->Size = System::Drawing::Size(125, 22);
			this->label_client_controll->TabIndex = 0;
			this->label_client_controll->Text = L"Client Control";
			this->label_client_controll->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			// 
			// panel_plotterstage
			// 
			this->panel_plotterstage->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->panel_plotterstage->Controls->Add(this->label_sensorOK);
			this->panel_plotterstage->Controls->Add(this->button_initialization);
			this->panel_plotterstage->Controls->Add(this->label_plotterstage);
			this->panel_plotterstage->Location = System::Drawing::Point(650, 5);
			this->panel_plotterstage->Name = L"panel_plotterstage";
			this->panel_plotterstage->Size = System::Drawing::Size(135, 75);
			this->panel_plotterstage->TabIndex = 5;
			// 
			// label_sensorOK
			// 
			this->label_sensorOK->Font = (gcnew System::Drawing::Font(L"Arial", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->label_sensorOK->Location = System::Drawing::Point(5, 50);
			this->label_sensorOK->Name = L"label_sensorOK";
			this->label_sensorOK->Size = System::Drawing::Size(125, 20);
			this->label_sensorOK->TabIndex = 2;
			this->label_sensorOK->Text = L"Sensor:";
			this->label_sensorOK->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			// 
			// button_initialization
			// 
			this->button_initialization->Font = (gcnew System::Drawing::Font(L"Arial", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_initialization->Location = System::Drawing::Point(18, 25);
			this->button_initialization->Name = L"button_initialization";
			this->button_initialization->Size = System::Drawing::Size(100, 26);
			this->button_initialization->TabIndex = 1;
			this->button_initialization->Text = L"Initialization";
			this->button_initialization->UseVisualStyleBackColor = true;
			this->button_initialization->Click += gcnew System::EventHandler(this, &Form1::button_initialization_Click);
			// 
			// label_plotterstage
			// 
			this->label_plotterstage->Font = (gcnew System::Drawing::Font(L"Arial", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->label_plotterstage->Location = System::Drawing::Point(5, 0);
			this->label_plotterstage->Name = L"label_plotterstage";
			this->label_plotterstage->Size = System::Drawing::Size(125, 22);
			this->label_plotterstage->TabIndex = 0;
			this->label_plotterstage->Text = L"Plotter Stage";
			this->label_plotterstage->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			// 
			// timer_plotter
			// 
			this->timer_plotter->Tick += gcnew System::EventHandler(this, &Form1::timer_plotter_Tick);
			// 
			// panel_automod
			// 
			this->panel_automod->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->panel_automod->Controls->Add(this->button_auto_scan);
			this->panel_automod->Controls->Add(this->button_auto_detect);
			this->panel_automod->Controls->Add(this->button_auto_send);
			this->panel_automod->Controls->Add(this->textBox_autofilename);
			this->panel_automod->Controls->Add(this->button_autosave);
			this->panel_automod->Location = System::Drawing::Point(5, 491);
			this->panel_automod->Name = L"panel_automod";
			this->panel_automod->Size = System::Drawing::Size(640, 30);
			this->panel_automod->TabIndex = 6;
			// 
			// button_auto_scan
			// 
			this->button_auto_scan->Font = (gcnew System::Drawing::Font(L"Arial", 9, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_auto_scan->Location = System::Drawing::Point(220, 3);
			this->button_auto_scan->Name = L"button_auto_scan";
			this->button_auto_scan->Size = System::Drawing::Size(100, 22);
			this->button_auto_scan->TabIndex = 4;
			this->button_auto_scan->Text = L"Auto Scan";
			this->button_auto_scan->UseVisualStyleBackColor = true;
			this->button_auto_scan->Click += gcnew System::EventHandler(this, &Form1::button_auto_scan_Click);
			// 
			// button_auto_detect
			// 
			this->button_auto_detect->Enabled = false;
			this->button_auto_detect->Font = (gcnew System::Drawing::Font(L"Arial", 9, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_auto_detect->Location = System::Drawing::Point(325, 3);
			this->button_auto_detect->Name = L"button_auto_detect";
			this->button_auto_detect->Size = System::Drawing::Size(100, 22);
			this->button_auto_detect->TabIndex = 3;
			this->button_auto_detect->Text = L"Auto Detect";
			this->button_auto_detect->UseVisualStyleBackColor = true;
			this->button_auto_detect->Click += gcnew System::EventHandler(this, &Form1::button_auto_detect_Click);
			// 
			// button_auto_send
			// 
			this->button_auto_send->Enabled = false;
			this->button_auto_send->Font = (gcnew System::Drawing::Font(L"Arial", 9, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_auto_send->Location = System::Drawing::Point(530, 3);
			this->button_auto_send->Name = L"button_auto_send";
			this->button_auto_send->Size = System::Drawing::Size(70, 22);
			this->button_auto_send->TabIndex = 2;
			this->button_auto_send->Text = L"Send";
			this->button_auto_send->UseVisualStyleBackColor = true;
			this->button_auto_send->Click += gcnew System::EventHandler(this, &Form1::button_auto_send_Click);
			// 
			// textBox_autofilename
			// 
			this->textBox_autofilename->Location = System::Drawing::Point(110, 3);
			this->textBox_autofilename->Name = L"textBox_autofilename";
			this->textBox_autofilename->Size = System::Drawing::Size(100, 20);
			this->textBox_autofilename->TabIndex = 1;
			// 
			// button_autosave
			// 
			this->button_autosave->Font = (gcnew System::Drawing::Font(L"Arial", 9, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_autosave->Location = System::Drawing::Point(5, 3);
			this->button_autosave->Name = L"button_autosave";
			this->button_autosave->Size = System::Drawing::Size(100, 22);
			this->button_autosave->TabIndex = 0;
			this->button_autosave->Text = L"Save Picture";
			this->button_autosave->UseVisualStyleBackColor = true;
			this->button_autosave->Click += gcnew System::EventHandler(this, &Form1::button_autosave_Click);
			// 
			// panel_demo
			// 
			this->panel_demo->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->panel_demo->Controls->Add(this->textBox_demo);
			this->panel_demo->Controls->Add(this->listBox_demo);
			this->panel_demo->Controls->Add(this->button_demo_nextstep);
			this->panel_demo->Controls->Add(this->button_demo_scan);
			this->panel_demo->Controls->Add(this->button_demo_load);
			this->panel_demo->Controls->Add(this->button_demo_detect);
			this->panel_demo->Location = System::Drawing::Point(5, 533);
			this->panel_demo->Name = L"panel_demo";
			this->panel_demo->Size = System::Drawing::Size(640, 30);
			this->panel_demo->TabIndex = 7;
			// 
			// textBox_demo
			// 
			this->textBox_demo->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->textBox_demo->Font = (gcnew System::Drawing::Font(L"Arial", 9, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->textBox_demo->Location = System::Drawing::Point(490, 3);
			this->textBox_demo->Name = L"textBox_demo";
			this->textBox_demo->ReadOnly = true;
			this->textBox_demo->Size = System::Drawing::Size(145, 21);
			this->textBox_demo->TabIndex = 6;
			this->textBox_demo->TextAlign = System::Windows::Forms::HorizontalAlignment::Center;
			// 
			// listBox_demo
			// 
			this->listBox_demo->Font = (gcnew System::Drawing::Font(L"Arial", 9, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->listBox_demo->FormattingEnabled = true;
			this->listBox_demo->ItemHeight = 15;
			this->listBox_demo->Items->AddRange(gcnew cli::array< System::Object^  >(9) {L"DemoScan01", L"DemoScan02", L"DemoScan03", 
				L"DemoScan04", L"DemoDetect01", L"DemoDetect02", L"DemoDetect03", L"DemoDetect04", L"DemoDetect05"});
			this->listBox_demo->Location = System::Drawing::Point(5, 3);
			this->listBox_demo->Name = L"listBox_demo";
			this->listBox_demo->Size = System::Drawing::Size(120, 19);
			this->listBox_demo->TabIndex = 5;
			// 
			// button_demo_nextstep
			// 
			this->button_demo_nextstep->Enabled = false;
			this->button_demo_nextstep->Font = (gcnew System::Drawing::Font(L"Arial", 9, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_demo_nextstep->Location = System::Drawing::Point(380, 2);
			this->button_demo_nextstep->Name = L"button_demo_nextstep";
			this->button_demo_nextstep->Size = System::Drawing::Size(100, 22);
			this->button_demo_nextstep->TabIndex = 4;
			this->button_demo_nextstep->Text = L"Next Step";
			this->button_demo_nextstep->UseVisualStyleBackColor = true;
			this->button_demo_nextstep->Click += gcnew System::EventHandler(this, &Form1::button_demo_nextstep_Click);
			// 
			// button_demo_scan
			// 
			this->button_demo_scan->Enabled = false;
			this->button_demo_scan->Font = (gcnew System::Drawing::Font(L"Arial", 9, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_demo_scan->Location = System::Drawing::Point(231, 2);
			this->button_demo_scan->Name = L"button_demo_scan";
			this->button_demo_scan->Size = System::Drawing::Size(70, 22);
			this->button_demo_scan->TabIndex = 3;
			this->button_demo_scan->Text = L"Scan";
			this->button_demo_scan->UseVisualStyleBackColor = true;
			this->button_demo_scan->Click += gcnew System::EventHandler(this, &Form1::button_demo_scan_Click);
			// 
			// button_demo_load
			// 
			this->button_demo_load->Font = (gcnew System::Drawing::Font(L"Arial", 9, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_demo_load->Location = System::Drawing::Point(126, 2);
			this->button_demo_load->Name = L"button_demo_load";
			this->button_demo_load->Size = System::Drawing::Size(100, 22);
			this->button_demo_load->TabIndex = 1;
			this->button_demo_load->Text = L"Load Picture";
			this->button_demo_load->UseVisualStyleBackColor = true;
			this->button_demo_load->Click += gcnew System::EventHandler(this, &Form1::button_demo_load_Click);
			// 
			// button_demo_detect
			// 
			this->button_demo_detect->Enabled = false;
			this->button_demo_detect->Font = (gcnew System::Drawing::Font(L"Arial", 9, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->button_demo_detect->Location = System::Drawing::Point(307, 2);
			this->button_demo_detect->Name = L"button_demo_detect";
			this->button_demo_detect->Size = System::Drawing::Size(70, 22);
			this->button_demo_detect->TabIndex = 0;
			this->button_demo_detect->Text = L"Detect";
			this->button_demo_detect->UseVisualStyleBackColor = true;
			this->button_demo_detect->Click += gcnew System::EventHandler(this, &Form1::button_demo_detect_Click);
			// 
			// timer_server2
			// 
			this->timer_server2->Interval = 10;
			this->timer_server2->Tick += gcnew System::EventHandler(this, &Form1::timer1_Tick);
			// 
			// timer_sensor
			// 
			this->timer_sensor->Tick += gcnew System::EventHandler(this, &Form1::timer_sensor_Tick);
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 14);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(792, 610);
			this->Controls->Add(this->panel_demo);
			this->Controls->Add(this->panel_automod);
			this->Controls->Add(this->panel_plotterstage);
			this->Controls->Add(this->panel_client);
			this->Controls->Add(this->panel_server);
			this->Controls->Add(this->panelWebCam);
			this->Controls->Add(this->pictureBox_WebCam);
			this->Font = (gcnew System::Drawing::Font(L"Arial", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->Name = L"Form1";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"Plotter Controller";
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox_WebCam))->EndInit();
			this->panelWebCam->ResumeLayout(false);
			this->panel_server->ResumeLayout(false);
			this->panel_server->PerformLayout();
			this->panel_client->ResumeLayout(false);
			this->panel_client->PerformLayout();
			this->panel_plotterstage->ResumeLayout(false);
			this->panel_automod->ResumeLayout(false);
			this->panel_automod->PerformLayout();
			this->panel_demo->ResumeLayout(false);
			this->panel_demo->PerformLayout();
			this->ResumeLayout(false);

		}
#pragma endregion
//|----------------------------------------------------------------------------------------------------------------|
//|                                               Other Functions                                                  |
//|----------------------------------------------------------------------------------------------------------------|
private: void ChangeControlEnable(bool b){
			 button_server_start->Enabled=b;
			 button_server_stop->Enabled=!b;

			 button_cubeXup->Enabled=b;
			 button_cubeXdown->Enabled=b;
			 button_cubeYleft->Enabled=b;
			 button_cubeYright->Enabled=b;
			 button_cubeZup->Enabled=b;
			 button_cubeZdown->Enabled=b;
			 button_cubeRleft->Enabled=b;
			 button_cubeRright->Enabled=b;
			 button_cubeGopen->Enabled=b;
			 button_cubeGclose->Enabled=b;

			 listBox_precision->Enabled=b;
			 button_cubeXhome->Enabled=b;
			 button_cubeYhome->Enabled=b;
			 button_cubeZhome->Enabled=b;
			 button_cubeRhome->Enabled=b;
			 button_cubeGhome->Enabled=b;
			 button_haltall->Enabled=b;

			 textBox_cubeX->Enabled=b;
			 textBox_cubeY->Enabled=b;
			 textBox_cubeZ->Enabled=b;
			 textBox_cubeR->Enabled=b;
			 textBox_cubeG->Enabled=b;
		 }

private: std::string getPrecision(){
				 Int32 tmp=listBox_precision->TopIndex;
				 return (const char*)(Runtime::InteropServices::Marshal::StringToHGlobalAnsi(tmp.ToString())).ToPointer();
			 }

//|----------------------------------------------------------------------------------------------------------------|
//|                                        WebCamera Controll Functions                                            |
//|----------------------------------------------------------------------------------------------------------------|
//START BUTTON
private: System::Void button_webcam_start_Click(System::Object^  sender, System::EventArgs^  e){
			 if (webcam->Start()){
				button_webcam_display->Enabled=true;
				button_webcam_stop->Enabled=true;
				button_webcam_capture->Enabled=true;
				button_webcam_start->Enabled=false;
				}
			 else{
				MessageBox::Show(this,"WebCamera is not connected","WebCam Error",MessageBoxButtons::OK, MessageBoxIcon::Error);
			 }
		 }
//STOP BUTTON
private: System::Void button_webcam_stop_Click(System::Object^  sender, System::EventArgs^  e){
			 webcam->Release();
			 button_webcam_display->Enabled=false;;
			 button_webcam_stop->Enabled=false;;
			 button_webcam_capture->Enabled=false;
			 button_webcam_start->Enabled=true;
		 }
//DISPLAY BUTTON
private: System::Void button_webcam_display_Click(System::Object^  sender, System::EventArgs^  e){
			 webcam->Display();
			 timer_webcam->Enabled=true;
		 }
//TIMER for DISPLAY refresh
private: System::Void timer_webcam_Tick(System::Object^  sender, System::EventArgs^  e){
			 webcam->Refresh();
		 }
//CAPTURE BUTTON
private: System::Void button_webcam_capture_Click(System::Object^  sender, System::EventArgs^  e){
			 Bitmap ^img=gcnew Bitmap(640,480,Imaging::PixelFormat::Format24bppRgb);
			 image=webcam->getImage();
			 pictureBox_WebCam->Image=image;
		 }
//|----------------------------------------------------------------------------------------------------------------|
//|                                      Server Connection Functions                                               |
//|----------------------------------------------------------------------------------------------------------------|
private: System::Void button_server_start_Click(System::Object^  sender, System::EventArgs^  e){
			 try{
			 server->Start();
			 timer_server->Enabled=true;
			 ChangeControlEnable(false);
			 }catch(System::Net::Sockets::SocketException^ ex){ex;}
		 }
private: System::Void button_server_stop_Click(System::Object^  sender, System::EventArgs^  e){
			 ChangeControlEnable(true);
			 timer_server->Enabled=false;
			 server->Stop();
		 }
private: System::Void timer_server_Tick(System::Object^  sender, System::EventArgs^  e){
			 server->Tick();
			 String^ msg=server->getMSG();
			 if (msg!=nullptr){
				if (msg->Substring(msg->Length-1,1)==L"$") msg=msg->Substring(0,msg->Length-1);
				 Order* tmp=new Order((const char*)(Runtime::InteropServices::Marshal::StringToHGlobalAnsi(msg)).ToPointer());
				if (tmp->isVisible()) textBox_server_msg->Text=msg;
				Order* answer=robot->Exec(tmp);
				server->sendMSG(gcnew String(answer->tostring().c_str()));
			 }
		 }

private: System::Void button_auto_send_Click(System::Object^  sender, System::EventArgs^  e) {
			planserver->Start();
			timer_server2->Enabled=true;
		 }

private: System::Void timer1_Tick(System::Object^  sender, System::EventArgs^  e) {
			 planserver->Tick();
			 String^ msg=planserver->getMSG();
			 if (msg==nullptr) return;
			 if (msg->Contains("SCAN")){
				 if (objectsearcher->isValid()) planserver->sendMSG("READY "+objectsearcher->number().ToString()+"$");
				 else planserver->sendMSG("WAIT$");
			 }
			 if (msg->Contains("NEXT")){
				 String^ s=objectsearcher->getObject(counter);
				 if (s->Contains("ERROR")) {
					 planserver->sendMSG("ERROR");
					 return;
				 }
				 planserver->sendMSG(s+"$");
				 ++counter;
			 }
			 if (msg->Contains("GETEND")){
				 MessageBox::Show(this,"Sending information Complete","Sending Complete",MessageBoxButtons::OK, MessageBoxIcon::None);
			 }

			 if (msg->Substring(0,2)->Contains("CO")){
				 std::ofstream file;
				 file.open("commads.txt");
				 file << (const char*)(Runtime::InteropServices::Marshal::StringToHGlobalAnsi(msg->Substring(3))).ToPointer();
			 }

			 if (msg->Contains("COEND")){
				 timer_server2->Enabled=false;
				 planserver->Stop();
			 }
		 }

//|----------------------------------------------------------------------------------------------------------------|
//|                                                 Controll Functions                                             |
//|----------------------------------------------------------------------------------------------------------------|

private: System::Void button_initialization_Click(System::Object^  sender, System::EventArgs^  e){
			 try{
				robot= new Robot();
			 }catch (void* ){
				 MessageBox::Show(this,"PlotterStage is not connected","PlotterStage Error",MessageBoxButtons::OK, MessageBoxIcon::Error);
				 return;
			 }
			 	 
			 autocontrol=gcnew AutoControl(robot,objectsearcher,webcam,pictureBox_WebCam);
			 connstat = sensorinfo->UsePort("COM7");
			 inputstat = sensorinfo->GetInputStatus();


			 if (connstat==ConnStatus::Conn){
				 label_sensorOK->Text="SENSOR OK";
				 timer_sensor->Enabled=true;
			 }
			 else {
				 label_sensorOK->Text="SENSOR FAILED";
				 MessageBox::Show(this,"Sensor don't connected","Sensor Error",MessageBoxButtons::OK, MessageBoxIcon::Error);
			 }

			 ChangeControlEnable(true);
			 timer_plotter->Enabled=true;
			 
		 }

private: System::Void timer_sensor_Tick(System::Object^  sender, System::EventArgs^  e) {
			 inputstat = this->sensorinfo->GetInputStatus();
			 if (inputstat==InputStatus::Wrong){
				 	 label_sensorOK->Text="Wrong";
			 }
			 if (inputstat==InputStatus::No_Input){
				 	 label_sensorOK->Text="No_input";
			 }
			 if (inputstat==InputStatus::OK){
				 	 label_sensorOK->Text="OK";
			 }
			 if(inputstat == InputStatus::OK){
				 cli::array<int,1>^ sensordata = this->sensorinfo->GetSensorData();
				 if (sensordata[2] > 500 || sensordata[3] > 500 || sensordata[4] > 500 || sensordata[5] > 500){
					MessageBox::Show(this,"Collosion Error -> PlotterStage halted","Collosion Error",MessageBoxButtons::OK, MessageBoxIcon::Error);
				 }
					
			 }
			 else {
				 label_sensorOK->Text="SENSOR FAILED";
				 MessageBox::Show(this,"Sensor don't connected","Sensor Error",MessageBoxButtons::OK, MessageBoxIcon::Error);
				 timer_sensor->Enabled=false;
			 }

		 }

private: System::Void button_cubeXdown_Click(System::Object^  sender, System::EventArgs^  e) {
			 robot->Exec(new Order("M0#"+getPrecision()));
		 }
private: System::Void button_cubeXup_Click(System::Object^  sender, System::EventArgs^  e) {
			 robot->Exec(new Order("W0#"+getPrecision()));
		 }
private: System::Void button_cubeYleft_Click(System::Object^  sender, System::EventArgs^  e) {
			 robot->Exec(new Order("M1#"+getPrecision()));
		 }
private: System::Void button_cubeYright_Click(System::Object^  sender, System::EventArgs^  e) {
			 robot->Exec(new Order("W1#"+getPrecision()));
		 }
private: System::Void button_cubeZup_Click(System::Object^  sender, System::EventArgs^  e) {
			 robot->Exec(new Order("M2#"+getPrecision()));
		 }
private: System::Void button_cubeZdown_Click(System::Object^  sender, System::EventArgs^  e) {
			 robot->Exec(new Order("W2#"+getPrecision()));
		 }
private: System::Void button_cubeRleft_Click(System::Object^  sender, System::EventArgs^  e) {
			 robot->Exec(new Order("M3#"+getPrecision()));
		 }
private: System::Void button_cubeRright_Click(System::Object^  sender, System::EventArgs^  e) {
			 robot->Exec(new Order("W3#"+getPrecision()));
		 }
private: System::Void button_cubeGopen_Click(System::Object^  sender, System::EventArgs^  e) {
			 robot->Exec(new Order("M4#"+getPrecision()));
		 }
private: System::Void button_cubeGclose_Click(System::Object^  sender, System::EventArgs^  e) {
			 robot->Exec(new Order("W4#"+getPrecision()));
		 }
private: System::Void button_cubeXhome_Click(System::Object^  sender, System::EventArgs^  e) {
			 robot->Exec(new Order("H0"));
		 }
private: System::Void button_cubeYhome_Click(System::Object^  sender, System::EventArgs^  e) {
			 robot->Exec(new Order("H1"));
		 }
private: System::Void button_cubeZhome_Click(System::Object^  sender, System::EventArgs^  e) {
			 robot->Exec(new Order("H2"));
		 }
private: System::Void button_cubeRhome_Click(System::Object^  sender, System::EventArgs^  e) {
			 robot->Exec(new Order("H3"));
		 }
private: System::Void button_cubeGhome_Click(System::Object^  sender, System::EventArgs^  e) {
			 robot->Exec(new Order("H4"));
		 }
private: System::Void button_haltall_Click(System::Object^  sender, System::EventArgs^  e) {
			 robot->Exec(new Order("S9"));
		 }

private: System::Void timer_plotter_Tick(System::Object^  sender, System::EventArgs^  e) {
			 textBox_cubeX->Text=robot->Get(0).ToString();
			 textBox_cubeY->Text=robot->Get(1).ToString();
			 textBox_cubeZ->Text=robot->Get(2).ToString();
			 textBox_cubeR->Text=robot->Get(3).ToString();
			 textBox_cubeG->Text=robot->Get(4).ToString();
			 checkBox_cubeX->Checked=robot->IsMoving(0);
			 checkBox_cubeY->Checked=robot->IsMoving(1);
			 checkBox_cubeZ->Checked=robot->IsMoving(2);
			 checkBox_cubeR->Checked=robot->IsMoving(3);
			 checkBox_cubeG->Checked=robot->IsMoving(4);
		 }
private: System::Void button_autosave_Click(System::Object^  sender, System::EventArgs^  e) {
			 String^ s=textBox_autofilename->Text;
			 if (s->Length == 0) {
				 MessageBox::Show(this,"No File Name","No File Name",MessageBoxButtons::OK,MessageBoxIcon::Error); 
				 return;
			 }
			 try{
				 _mkdir("Pictures");
				 image->Save("Pictures\\"+s+".png");
				  MessageBox::Show(this,"The picture "+s+".png is saved","Succesfull Saved",MessageBoxButtons::OK, MessageBoxIcon::None);
			 }catch (Exception^ ex) {ex;}
		 }


private: System::Void button_demo_detect_Click(System::Object^  sender, System::EventArgs^  e) {
			 button_demo_load->Enabled=false;
			 button_demo_scan->Enabled=false;
			 button_demo_detect->Enabled=false;
			 button_demo_nextstep->Enabled=true;
			 demo=11;
			 image=objectsearcher->DemoDetect(image,demo-10,textBox_demo->Text);
			 pictureBox_WebCam->Image=image;
		 }


private: System::Void button_demo_load_Click(System::Object^  sender, System::EventArgs^  e) {
			 try{
				 Int32 tmp=listBox_demo->TopIndex;
				 if (tmp==0) image=gcnew Bitmap("Demo\\DemoScan01.png");
				 if (tmp==1) image=gcnew Bitmap("Demo\\DemoScan02.png");
				 if (tmp==2) image=gcnew Bitmap("Demo\\DemoScan03.png");
				 if (tmp==3) image=gcnew Bitmap("Demo\\DemoScan04.png");
				 if (tmp==4) image=gcnew Bitmap("Demo\\DemoDetect01.png");
				 if (tmp==5) image=gcnew Bitmap("Demo\\DemoDetect02.png");
				 if (tmp==6) image=gcnew Bitmap("Demo\\DemoDetect03.png");
				 if (tmp==7) image=gcnew Bitmap("Demo\\DemoDetect04.png");
				 if (tmp==8) image=gcnew Bitmap("Demo\\DemoDetect05.png");
				 pictureBox_WebCam->Image=image;
				 button_demo_detect->Enabled=true;
				 button_demo_scan->Enabled=true;
			 }catch (Exception^ ex) {ex;}
		 }

private: System::Void button_demo_nextstep_Click(System::Object^  sender, System::EventArgs^  e) {
			 if (demo < 20){
				 ++demo;
				 if (demo == 15){
					 button_demo_load->Enabled=true;
					 button_demo_detect->Enabled=true;
					 button_demo_scan->Enabled=true;
					 button_demo_nextstep->Enabled=false;
				 }
				 image=objectsearcher->DemoDetect(image,demo-10,textBox_demo->Text);
				 pictureBox_WebCam->Image=image;
			 }
			 else{
			  ++demo;
			  if (demo == 24){
					 button_demo_load->Enabled=true;
					 button_demo_detect->Enabled=true;
					 button_demo_scan->Enabled=true;
					 button_demo_nextstep->Enabled=false;
				 }
			  image=objectsearcher->DemoScan(image,demo-20,textBox_demo->Text);
			  pictureBox_WebCam->Image=image;
			 }
		 }
private: System::Void button_demo_scan_Click(System::Object^  sender, System::EventArgs^  e) {
			 button_demo_load->Enabled=false;
			 button_demo_detect->Enabled=false;
			 button_demo_scan->Enabled=false;
			 button_demo_nextstep->Enabled=true;
			 demo=21;
			 image=objectsearcher->DemoScan(image,demo-20,textBox_demo->Text);
			 pictureBox_WebCam->Image=image;
		 }

private: System::Void button_auto_scan_Click(System::Object^  sender, System::EventArgs^  e) {
			 try{
				 robot->IsMoving(0);
				 webcam->Refresh();
		
			 button_auto_scan->Enabled=false;
			 button_auto_detect->Enabled=true;
			 autocontrol->AutoScan();
			 	 }catch (Exception^ ex) 
			 {
				 ex;
				 MessageBox::Show(this,"Please initialize PlotterStage and start WebCam","Initialization Error",MessageBoxButtons::OK, MessageBoxIcon::Error);
				 }
		 }


private: System::Void button_auto_detect_Click(System::Object^  sender, System::EventArgs^  e) {
			 button_auto_detect->Enabled=false;
			 button_auto_send->Enabled=true;
			 autocontrol->AutoDetect();

		 }

};
}

