#ifndef PLOTTEROBJECT_HPP
#define PLOTTEROBJECT_HPP

#include "Coord.hpp"

//Colors -1:Unknown 1:Red 2:Green 3:blue 4:yellow

class PlotterObject{

	private:
		Coord coord;
		int rotation;
		int color;
		int basetype;
		int type;
		int orientation;

	public:
		PlotterObject();
		PlotterObject(Coord _coord,int _rotation,int _color);
		Coord getCoord();
		int getRotation();
		int getColor();
		int getBaseType();
		int getType();
		int getOrientation();
		void setCoord(Coord _coord);
		void setRotation(int _rotation);
		void setColor(int _color);
		void setBaseType(int _basetype);
		void setType(int _type);
		void setOrientation(int _orientation);
		System::String^ toStr();
		System::String^ toSend();
};

PlotterObject::PlotterObject(){
	coord = Coord();
	rotation=0;
	color=-1;
	basetype=-1;
	type=-1;
	orientation=-1;
}

PlotterObject::PlotterObject(Coord _coord,int _rotation,int _color){
	coord=_coord;
	rotation=_rotation;
	color=_color;
	basetype=-1;
	type=-1;
	orientation=-1;
}

Coord PlotterObject::getCoord(){
	return coord;
}

int PlotterObject::getRotation(){
	return rotation;
}

int PlotterObject::getColor(){
	return color;
}

int PlotterObject::getBaseType(){
	return basetype;
}

int PlotterObject::getType(){
	return type;
}

int PlotterObject::getOrientation(){
	return orientation;
}

void PlotterObject::setCoord(Coord _coord){
	coord=_coord;
}

void PlotterObject::setRotation(int _rotation){
	rotation=_rotation;
}

void PlotterObject::setColor(int _color){
	color=_color;
}

void PlotterObject::setBaseType(int _basetype){
	basetype=_basetype;
}

void PlotterObject::setType(int _type){
	type=_type;
}

void PlotterObject::setOrientation(int _orientation){
	orientation=_orientation;
}

System::String^ PlotterObject::toStr(){
	return L"[("+coord.getX().ToString()+L":"+coord.getY().ToString()+L":"+rotation.ToString()+L") |"+basetype+L"|"+type+L"|"+orientation+"| C:"+color.ToString()+L"]";
}

System::String^ PlotterObject::toSend(){
	return basetype+" "+type+" "+coord.getX()+" "+coord.getY()+" 0 "+rotation+" "+orientation+" "+color;
}
#endif