#ifndef WEBCAM_HPP
#define WEBCAM_HPP

ref class WebCam{
	private:
		CvCapture* capture;
	public:
		WebCam();
		bool Start();
		void Display();
		void Refresh();
		IplImage* getIplImage();
		System::Drawing::Bitmap^ getImage();
		void Release();
};

WebCam::WebCam(){
	capture=nullptr;
}

bool WebCam::Start(){
	try{
		capture=cvCaptureFromCAM(0);
	}catch (Exception^ ex) {ex; return false;}
	return 1;
}

void WebCam::Display(){
	cvNamedWindow("WebCam Display",1);
}

void WebCam::Refresh(){
	cvShowImage("WebCam Display",cvQueryFrame(capture));
}

IplImage* WebCam::getIplImage(){
	return cvQueryFrame(capture);
}

System::Drawing::Bitmap^ WebCam::getImage(){
	IplImage* rawImage=cvQueryFrame(capture);
	System::Drawing::Bitmap^ img=gcnew System::Drawing::Bitmap(640,480);
	int nl= rawImage->height;
	int nc= rawImage->width * rawImage->nChannels;
	int step= rawImage->widthStep;
	unsigned char* data=reinterpret_cast<unsigned char*>(rawImage->imageData);
	for(int i=0; i<nl; i++){
		for(int j=0; j<nc; j+= rawImage->nChannels){
			img->SetPixel(j/3,i,Color::FromArgb(data[j+2],data[j+1],data[j]));
		}
		data+= step;
	}		
	return img;
}


void WebCam::Release(){
	if (capture==nullptr) return;
	pin_ptr<CvCapture*> delcap = &this->capture;
	cvReleaseCapture(delcap);
}

#endif